import 'package:oobium_datastore_gen/src/generators/trigger_feature.dart';
import 'package:oobium_datastore_gen/src/model.dart';
import 'package:oobium_datastore_gen/src/schema_parser.dart';

class TriggerAdapterGenerator {

  final Model m;
  Schema get schema => m.schema;
  TriggerAdapterGenerator(this.m);

  String compile() =>
m.isSingleton ?
'''
class ${m.triggersName} {

  FutureOr<void> Function($onChangeParams)? onCreate;
  FutureOr<void> Function($onUpdateParams)? onUpdate;

  ${m.triggersName}({this.onCreate, this.onUpdate});
}
''' :
'''
class ${m.triggersName} {
 
  FutureOr<void> Function($onChangeParams)? onCreate;
  FutureOr<void> Function($onUpdateParams)? onUpdate;
  FutureOr<void> Function($onChangeParams)? onRemove;
 
  ${m.triggersName}({this.onCreate, this.onUpdate, this.onRemove});
}
''';

  String get onChangeParams => [
    '${schema.dsName} ds',
    '${m.snapName} ${m.varName}'
  ].join(',');

  String get onChangeArgs => [
    '_modelContext',
    m.varName
  ].join(',');

  String get onUpdateParams => [
    '${schema.dsName} ds',
    '${m.snapName} old',
    '${m.snapName} ${m.varName}'
  ].join(',');

  String get onUpdateArgs => [
    '_modelContext',
    'old',
    m.varName
  ].join(',');
}

